# Copyright (C) 2009 Sun Microsystems, Inc
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA 

# This script merges many static libraries into
# one big library on Unix.
SET(TARGET_LOCATION "/home/user/wrk/cnacl/build/libnacl.a")
SET(TARGET "nacl")
SET(STATIC_LIBS "/home/user/wrk/cnacl/build/crypto_hashblocks/sha512/inplace/libcrypto_hashblocks_sha512_inplace.a;/home/user/wrk/cnacl/build/crypto_hashblocks/sha256/ref/libcrypto_hashblocks_sha256_ref.a;/home/user/wrk/cnacl/build/crypto_scalarmult/curve25519/donna_c64/libcrypto_scalarmult_curve25519_donna_c64.a;/home/user/wrk/cnacl/build/crypto_hash/sha512/ref/libcrypto_hash_sha512_ref.a;/home/user/wrk/cnacl/build/crypto_hash/sha256/ref/libcrypto_hash_sha256_ref.a;/home/user/wrk/cnacl/build/crypto_stream/salsa20/amd64_xmm6/libcrypto_stream_salsa20_amd64_xmm6.a;/home/user/wrk/cnacl/build/crypto_stream/aes128ctr/core2/libcrypto_stream_aes128ctr_core2.a;/home/user/wrk/cnacl/build/crypto_stream/salsa2012/amd64_xmm6/libcrypto_stream_salsa2012_amd64_xmm6.a;/home/user/wrk/cnacl/build/crypto_stream/xsalsa20/ref/libcrypto_stream_xsalsa20_ref.a;/home/user/wrk/cnacl/build/crypto_stream/salsa208/amd64_xmm6/libcrypto_stream_salsa208_amd64_xmm6.a;/home/user/wrk/cnacl/build/crypto_verify/16/ref/libcrypto_verify_16_ref.a;/home/user/wrk/cnacl/build/crypto_verify/32/ref/libcrypto_verify_32_ref.a;/home/user/wrk/cnacl/build/crypto_box/curve25519xsalsa20poly1305/ref/libcrypto_box_curve25519xsalsa20poly1305_ref.a;/home/user/wrk/cnacl/build/crypto_onetimeauth/poly1305/amd64/libcrypto_onetimeauth_poly1305_amd64.a;/home/user/wrk/cnacl/build/crypto_core/salsa208/ref/libcrypto_core_salsa208_ref.a;/home/user/wrk/cnacl/build/crypto_core/hsalsa20/ref/libcrypto_core_hsalsa20_ref.a;/home/user/wrk/cnacl/build/crypto_core/salsa2012/ref/libcrypto_core_salsa2012_ref.a;/home/user/wrk/cnacl/build/crypto_core/salsa20/ref/libcrypto_core_salsa20_ref.a;/home/user/wrk/cnacl/build/crypto_auth/hmacsha256/ref/libcrypto_auth_hmacsha256_ref.a;/home/user/wrk/cnacl/build/crypto_auth/hmacsha512256/ref/libcrypto_auth_hmacsha512256_ref.a;/home/user/wrk/cnacl/build/crypto_sign/edwards25519sha512batch/ref/libcrypto_sign_edwards25519sha512batch_ref.a;/home/user/wrk/cnacl/build/crypto_secretbox/xsalsa20poly1305/ref/libcrypto_secretbox_xsalsa20poly1305_ref.a")
SET(CMAKE_CURRENT_BINARY_DIR "/home/user/wrk/cnacl/build")
SET(CMAKE_AR "/usr/bin/ar")
SET(CMAKE_RANLIB "/usr/bin/ranlib")


SET(TEMP_DIR ${CMAKE_CURRENT_BINARY_DIR}/merge_archives_${TARGET})
MAKE_DIRECTORY(${TEMP_DIR})
# Extract each archive to its own subdirectory(avoid object filename clashes)
FOREACH(LIB ${STATIC_LIBS})
  GET_FILENAME_COMPONENT(NAME_NO_EXT ${LIB} NAME_WE)
  SET(TEMP_SUBDIR ${TEMP_DIR}/${NAME_NO_EXT})
  MAKE_DIRECTORY(${TEMP_SUBDIR})
  EXECUTE_PROCESS(
    COMMAND ${CMAKE_AR} -x ${LIB}
    WORKING_DIRECTORY ${TEMP_SUBDIR}
  )

  FILE(GLOB_RECURSE LIB_OBJECTS "${TEMP_SUBDIR}/*")
  SET(OBJECTS ${OBJECTS} ${LIB_OBJECTS})
ENDFOREACH()

# Use relative paths, makes command line shorter.
GET_FILENAME_COMPONENT(ABS_TEMP_DIR ${TEMP_DIR} ABSOLUTE)
FOREACH(OBJ ${OBJECTS})
  FILE(RELATIVE_PATH OBJ ${ABS_TEMP_DIR} ${OBJ})
  FILE(TO_NATIVE_PATH ${OBJ} OBJ)
  SET(ALL_OBJECTS ${ALL_OBJECTS} ${OBJ})
ENDFOREACH()

FILE(TO_NATIVE_PATH ${TARGET_LOCATION} ${TARGET_LOCATION})
# Now pack the objects into library with ar.
EXECUTE_PROCESS(
  COMMAND ${CMAKE_AR} -r ${TARGET_LOCATION} ${ALL_OBJECTS}
  WORKING_DIRECTORY ${TEMP_DIR}
)
EXECUTE_PROCESS(
  COMMAND ${CMAKE_RANLIB} ${TARGET_LOCATION}
  WORKING_DIRECTORY ${TEMP_DIR}
)

# Cleanup
FILE(REMOVE_RECURSE ${TEMP_DIR})
